unit TernarySeries;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, VclTee.TeeGDIPlus, Vcl.ExtCtrls,
  VCLTee.TeEngine, VCLTee.TeeSurfa, VCLTee.TeeTernary, Vcl.StdCtrls,
  VCLTee.TeeProcs, VCLTee.Chart, VCLTee.TeeURL, VCLTee.TeeSeriesTextEd, Data.DB,
  kbmMemTable, unitkbmmemorytable, commasplit, kbmMemCSVStreamFormat, Data.Win.ADODB,VCLTee.Series,
  VCLTee.DBChart;

type
  TTernarySeriesForm = class(TForm)
    Button1: TButton;
    Panel1: TPanel;
    SeriesTextSource1: TSeriesTextSource;
    kbmCSVStreamFormat1: TkbmCSVStreamFormat;
    Chart1: TDBChart;
    kbmMemTable1: TkbmMemTable;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Chart1BeforeDrawAxes(Sender: TObject);
  private
//    Series1: TTernarySeries;
    SeriesListT: TStringList;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  TernarySeriesForm: TTernarySeriesForm;
  Series1: TTernarySeries;

implementation

{$R *.dfm}

Uses EditChar, TeeConst;

procedure TTernarySeriesForm.Button1Click(Sender: TObject);
begin
  EditSeries(Self,Series1);
end;

procedure TTernarySeriesForm.Chart1BeforeDrawAxes(Sender: TObject);
begin
  Chart1.Legend.Title.Visible := Series1.ColorEachPoint;
end;

procedure TTernarySeriesForm.FormCreate(Sender: TObject);
var
  z: boolean;
  Lkbm: TkbmMemTable;
  af: TFieldDefs;
  i: integer;
  LADO: TADOQuery;
  aDataset: TDataset;

begin
  inherited;

  SeriesListT := TStringList.Create;
  kbmMemTable1 := TkbmMemTable.Create(nil);
  kbmMemTable1.DefaultFormat := kbmCSVStreamFormat1;
  kbmMemTable1.CommaTextFormat := kbmCSVStreamFormat1;
  aDataSet := kbmMemTable1;

  af := kbmMemTable1.FieldDefs;
  af.Clear;

  with af.AddFieldDef do
  begin
    Name := 'Sample Site';       // Text
    DataType := ftString;
  end;

  with af.AddFieldDef do
  begin
    Name := 'Sample Date';
    DataType := ftString;
  end;

  with af.AddFieldDef do
  begin
    Name := 'Na/1000';        // X
    DataType := ftFloat;
  end;

  with af.AddFieldDef do
  begin
    Name := 'Sqrt(Mg)';        // Y
    DataType := ftFloat;
  end;

  with af.AddFieldDef do
  begin
    Name := 'K/100';          // Z
    DataType := ftFloat;
  end;

  with af.AddFieldDef do
  begin
    Name := 'Conc Sum';          // Radius
    DataType := ftFloat;
  end;

  with af.AddFieldDef do
  begin
    Name := 'Weight';          // Weight
    DataType := ftFloat;
  end;

  with af.AddFieldDef do
  begin
    Name := 'Site and Date';          // Text
    DataType := ftString;
  end;

  kbmMemTable1.Open;
  kbmMemTable1.LoadFromFile('C:\Code_Test_Progs\TernaryGraph\Na-Mg-K.csv');
  i := kbmMemTable1.RecordCount;

  Series1 := TTernarySeries.Create(Owner);
  Series1.ParentChart := Chart1;

  Series1.DataSource := kbmMemTable1;

  Series1.UseColorRange:=true;
  Series1.VertexTitles[0][0] := 'Na/1000' ;
  Series1.VertexTitles[1][0] := 'Sqrt(Mg)' ;
  Series1.VertexTitles[2][0] := 'K/100' ;

  Series1.XValues.ValueSource := 'Na/1000';
  Series1.YValues.ValueSource := 'Sqrt(Mg)';
  Series1.ZValues.ValueSource := 'K/100';
  Series1.WeightValues.ValueSource := 'Conc Sum';
//  Series1.WeightValues.ValueSource := 'Weight';
  Series1.RadiusValues.ValueSource := 'Conc Sum';
  Series1.XLabelsSource := 'Site and Date';

  Series1.Pointer.Style:=psCircle;
  Series1.Pointer.Transparency:=50;

  Series1.TernaryStyle:=tsBubble;
  Series1.TernaryLegendStyle:=tlsBubbleWeight;

//  Chart1.Legend.Title.Text.Add(TeeMsg_TernaryMarkRadius + ', ' + TeeMsg_TernaryMarkWeight);
  Chart1.Legend.TextStyle := ltsPlain;
  Chart1.Legend.Title.Text.Add('Sample Site  Sample Date');
  Chart1.Legend.Title.TextAlignment := taLeftJustify;
  Chart1.Legend.Width :=30;
  Chart1.Legend.Title.Visible:=true;
end;

end.
